import { HatchetClient } from '@clients/hatchet-client';
import { Action, ActionListener } from '@clients/dispatcher/action-listener';
import { ActionEvent, ActionEventType } from '@protoc/dispatcher';
import HatchetPromise from '@util/hatchet-promise/hatchet-promise';
import { Workflow } from '@hatchet/workflow';
import { Logger } from '@hatchet/util/logger';
export type ActionRegistry = Record<Action['actionId'], Function>;
export declare class Worker {
    serviceName: string;
    client: HatchetClient;
    name: string;
    killing: boolean;
    handle_kill: boolean;
    action_registry: ActionRegistry;
    listener: ActionListener | undefined;
    futures: Record<Action['stepRunId'], HatchetPromise<any>>;
    logger: Logger;
    constructor(client: HatchetClient, options: {
        name: string;
        handleKill?: boolean;
    });
    register_workflow(workflow: Workflow, options?: {
        autoVersion?: boolean;
    }): Promise<void>;
    handle_start_step_run(action: Action): void;
    get_action_event(action: Action, eventType: ActionEventType, payload?: any): ActionEvent;
    handle_cancel_step_run(action: Action): void;
    stop(): Promise<void>;
    exit_gracefully(): Promise<void>;
    start(): Promise<void>;
}
