import * as z from 'zod';
import { CreateStep } from './step';
declare const StepsSchema: z.ZodArray<z.ZodObject<{
    name: z.ZodString;
    parents: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
}, "strip", z.ZodTypeAny, {
    name: string;
    parents?: string[] | undefined;
}, {
    name: string;
    parents?: string[] | undefined;
}>, "many">;
export type Steps = z.infer<typeof StepsSchema>;
export declare const CreateWorkflowSchema: z.ZodObject<{
    id: z.ZodString;
    description: z.ZodString;
    on: z.ZodUnion<[z.ZodObject<{
        cron: z.ZodString;
        event: z.ZodUndefined;
    }, "strip", z.ZodTypeAny, {
        cron: string;
        event?: undefined;
    }, {
        cron: string;
        event?: undefined;
    }>, z.ZodObject<{
        cron: z.ZodUndefined;
        event: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        event: string;
        cron?: undefined;
    }, {
        event: string;
        cron?: undefined;
    }>]>;
    steps: z.ZodArray<z.ZodObject<{
        name: z.ZodString;
        parents: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        name: string;
        parents?: string[] | undefined;
    }, {
        name: string;
        parents?: string[] | undefined;
    }>, "many">;
}, "strip", z.ZodTypeAny, {
    description: string;
    steps: {
        name: string;
        parents?: string[] | undefined;
    }[];
    id: string;
    on: {
        cron: string;
        event?: undefined;
    } | {
        event: string;
        cron?: undefined;
    };
}, {
    description: string;
    steps: {
        name: string;
        parents?: string[] | undefined;
    }[];
    id: string;
    on: {
        cron: string;
        event?: undefined;
    } | {
        event: string;
        cron?: undefined;
    };
}>;
export interface Workflow extends z.infer<typeof CreateWorkflowSchema> {
    steps: CreateStep<any>[];
}
export {};
